#!/usr/bin/env bx
use b
use src

opts *O

cstr options[][3] =
	{ "V", "version",   "" },
	{ "v", "verbose",   "" },
	{ "d", "dump",      "dump configuration" },
	{ "c", "compile",   "translate and compile only" },
	{ "t", "translate", "translate only" },
	{ "h", "headers",   "generate headers" },
	{ "r", "run",       "run only, do not compile" },
	{ "C", "clean",     "recompile, remove unneeded files" },
	{ "1", "b1file",    "generate b1 file" },
	{ "B", "nobackup",  "don't backup files" },
	{ NULL, NULL, NULL }

Main()
	bm_enabled = 0
	bm_start()
	O = get_options(options)
	tofree_block()
		init()
		config()
		setup()
#		dump_settings()
		new(v, vec, cstr, 16)
		eacharg(a)
			resolve_dep(a, v)
			Printf("%s ->", a)
			for_vec(i, v, cstr)
				Printf(" %s", *i)
			nl()
			vec_clear(v)
